bits 32

%include "Util.inc"


extern scheduling
extern schedule

extern handle_irq


%macro	handle_irq_x 2
	global %1
	align 4
%1:
	SAVE_ALL
	
	push	%2
	call	handle_irq
	add	esp, 4
	
	test	byte[scheduling], 0x1
	jz	no_schedule
	call	schedule
	
	RESTORE_ALL
	iret
%endmacro


section .text

no_schedule:
	RESTORE_ALL
	iret


	global	not_ready_irq
not_ready_irq:
	ret


handle_irq_x	handle_irq_0, 0
handle_irq_x	handle_irq_1, 1
handle_irq_x	handle_irq_2, 2
handle_irq_x	handle_irq_3, 3
handle_irq_x	handle_irq_4, 4
handle_irq_x	handle_irq_5, 5
handle_irq_x	handle_irq_6, 6
handle_irq_x	handle_irq_7, 7
handle_irq_x	handle_irq_8, 8
handle_irq_x	handle_irq_9, 9
handle_irq_x	handle_irq_10, 10
handle_irq_x	handle_irq_11, 11
handle_irq_x	handle_irq_12, 12
handle_irq_x	handle_irq_13, 13
handle_irq_x	handle_irq_14, 14
handle_irq_x	handle_irq_15, 15
