/******************************************************************************
 * MyOs	- my special operating system...
 *
 * 
 * This is free. If you want to use and fix this program, you can do that...
 *
 * 
 * it's mine only for me...
 *
 * Inhyuk, Kim... kkojiband@hotmail.com
 *
 ******************************************************************************/


#include <Types.h>
#include <Alloc.h>


/* ο heap  Ѵ...
 * 
 * limit	- heap  ũ⸦ Ÿ...
 */
int create_heap_area( HeapArea *heap, unsigned int base, unsigned int limit )
{
	heap->base		= base;
	heap->limit		= limit;
	heap->current	= base;
	
	heap->freeHead	= NULL;

	return 0;
}

void *alloc( HeapArea *heap, unsigned int size )
{
	MemBlock	*p, *pp, *ok = NULL, *okpp;


	if( size <= 0 )
		return NULL;

	/* 4 byte / 1 size... */
	size	= ( size + 3 ) >> 2;

	/* û size   free block  ִٸ Ѵ...
	 *
	 * free block list ü ˻ Ŀ  block   ũⰡ
	 *    Ѵ...
	 */
	p	= heap->freeHead;

	while( p != NULL )
	{
		if( p->size >= size )
		{
			if( ok == NULL || ok->size > p->size )
			{
				okpp	= pp;
				ok		= p;
			}
		}
	
		pp	= p;
		p	= p->freeNext;
	}

	/* ok  NULL ̸,  free block   ̴... */
	if( ok != NULL )
	{
		/* ٽ block header  USED_FLAG  Ѵ... */
		ok->flags	|= USED_FLAG;

		if( ok == heap->freeHead )
			heap->freeHead	= ok->freeNext;
		else
			okpp->freeNext	= ok->freeNext;
		
		return (void *)ok->base;
	}
		
	/* heap limit  ȮѴ... */
	if( heap->current+(size<<2)+MEMBLOCK_HEADER_SIZE > heap->base+heap->limit )
		return NULL;

	
	ok	= (MemBlock *)heap->current;

	heap->current	+= (size<<2) + MEMBLOCK_HEADER_SIZE;
	
	ok->freeNext	= NULL;
	ok->base		= (unsigned int)ok + MEMBLOCK_HEADER_SIZE;
	ok->size		= size;
	ok->flags		|= USED_FLAG;
	
	return (void *)ok->base;
}

int free( HeapArea *heap, void *block )
{
	MemBlock	*free, *p;


	/* block header  ּҰ Ѵ... */
	free	= (MemBlock *)((unsigned int)block - MEMBLOCK_HEADER_SIZE);
	
	free->flags		&= ~USED_FLAG;
	free->freeNext	= NULL;
	
	/* free block  ϳ  ̸ freeHead  Ѵ... */
	if( heap->freeHead == NULL )
	{
		heap->freeHead	= free;
	
		return 0;
	}
	
	p	= heap->freeHead;

	while( p->freeNext != NULL )
		p	= p->freeNext;

	p->freeNext	= free;
	
	return 0;
}
