/******************************************************************************
 * MyOs	- my special operating system...
 *
 * 
 * This is free. If you want to use and fix this program, you can do that...
 *
 *
 * it's mine only for me...
 * 
 * Inhyuk, Kim... kkojiband@hotmail.com
 *
 ******************************************************************************/


#include <Sys.h>
#include <Screen.h>
#include <Process.h>
#include <Idt.h>
#include <Io.h>
#include <Debug.h>


extern void	init_idt( void );
extern void	init_gdt( void );
extern void	init_irq( void );
extern void	init_mem( void );
extern void	init_process( void );
extern void	init_timer( void );
extern void	init_keyboard( void );
extern void	init_screen( void );
extern void	init_time( void );


/* Ϸ ؼ Ǵ bss section  ۰  Ÿ ̴...
 *   __bss_start  _end  ۰  Ÿ  
 * ƴ϶, ۰  ּҿ ġ ̴. ׷Ƿ  ۰  
 * Ұ ˷ &__bss_start, &_end    ؾѴ...
 */
extern unsigned int	__bss_start, _end;

static void	init_bss( void )
{
	unsigned int	*p;

	for( p = &__bss_start; p < &_end; p++ )
		*p	= 0;
}


extern int	shell( void );
extern int	thread1( void );
extern int	thread2( void );


static int init( void )
{
	init_timer();

	/* current process  foreground process  Ѵ... */
	set_to_foreground();
	
	init_keyboard();

	init_screen();

	/* interrupt  enable Ų... */
	sti();

	m_open( "keyboard", 0 );
	m_open( "screen", 0 );

	gotoxy( 0, 2 );

	m_write( 1, "Operating system initialize ok...!\n\n", 36 ); 
	
	/* init process  shell process  ϰ Ѵ... */
	create_thread( shell );

	m_exit();
	
	return 0;
}

int main( void )
{
	/*  interrupt  disable  ̴... */

	init_bss();

	init_idt();

	init_irq();

	init_mem();

	init_time();

	init_ide();

	init_process();

	/* init process  ϰ current process   · ... */
	create_thread( init );

	
	while(1)
		schedule();
	
	return 0;
}
